﻿// Keep this lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Controls\System\TcHmiControl\Source.d.ts" />

// Keep this lines for a best effort IntelliSense of Visual Studio 2013/2015.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery\jquery.js" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.js" />

(function (TcHmi) {

    TcHmi.Timer = {};
    TcHmi.Timer.Interval = undefined;

    var CountUpDownValue = function (CounterActive,Value,Step,IntervalTime,CountUp) {

        if (CounterActive === undefined || CounterActive === null)
            return;

        if (CountUp === undefined || CountUp === null)
            return;

        if (!Value)
            return;       

        if (!IntervalTime) {
            IntervalTime = 200;
        }           

        if (!Step) {
            Step = 1;
        }        

        if (TcHmi.Timer.Interval) {
            clearInterval(TcHmi.Timer.Interval);
        }
        
        if (CounterActive) {      
            TcHmi.Timer.Interval = setInterval(increaseSymbolValue, IntervalTime);
        }   

        function increaseSymbolValue() {          

            Value.readEx(function (data) {
                if (data.error === TcHmi.Errors.NONE) {
                    // Handle result value... 
                    var val = data.value;
                    var newVal;
                    if (CountUp) {
                        newVal = val + Step;
                    } else {
                        newVal = val - Step;
                    }                    

                    Value.write(newVal, function (data) {
                        if (data.error === TcHmi.Errors.NONE) {
                            // Handle success... 
                        } else {
                            // Handle error... 
                        }
                    });

                } else {
                    // Handle error... 
                }
            });

        };

    };
    
    TcHmi.Functions.registerFunction('CountUpDownValue', CountUpDownValue);
})(TcHmi);